// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f systemrestores.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use k8s_openapi::apimachinery::pkg::apis::meta::v1::Condition;
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// SystemRestoreSpec defines the desired state of the Longhorn SystemRestore
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "longhorn.io",
    version = "v1beta2",
    kind = "SystemRestore",
    plural = "systemrestores"
)]
#[kube(namespaced)]
#[kube(status = "SystemRestoreStatus")]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct SystemRestoreSpec {
    /// The system backup name in the object store.
    #[serde(rename = "systemBackup")]
    pub system_backup: String,
}

/// SystemRestoreStatus defines the observed state of the Longhorn SystemRestore
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct SystemRestoreStatus {
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub conditions: Option<Vec<Condition>>,
    /// The node ID of the responsible controller to reconcile this SystemRestore.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "ownerID")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub owner_id: Option<String>,
    /// The source system backup URL.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "sourceURL")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub source_url: Option<String>,
    /// The system restore state.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub state: Option<String>,
}
